3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
14 git_broken_path_fix
() {
25 case "$SANE_TOOL_PATH:$elem" in
26 (?
*:/bin | ?
*:/usr
/bin
)
27 path
="$path$sep$SANE_TOOL_PATH"
50 if test -z "$GIT_QUIET"
56 if test -n "$OPTIONS_SPEC"; then
63 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
64 parseopt_extra
="--keep-dashdash"
67 echo "$OPTIONS_SPEC" |
68 git rev-parse --parseopt $parseopt_extra -- "$@
" ||
72 dashless
=$
(basename "$0" |
sed -e 's/-/ /')
74 die
"Usage: $dashless $USAGE"
77 if [ -z "$LONG_USAGE" ]
79 LONG_USAGE
="Usage: $dashless $USAGE"
81 LONG_USAGE
="Usage: $dashless $USAGE
87 -h|
--h|
--he|
--hel|
--help)
94 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
96 GIT_REFLOG_ACTION
="$*"
97 export GIT_REFLOG_ACTION
102 if test -z "${GIT_EDITOR:+set}"
104 GIT_EDITOR
="$(git var GIT_EDITOR)" ||
return $?
107 eval "$GIT_EDITOR" '"$@"'
111 GREP_OPTIONS
= LC_ALL
=C
grep "$@"
115 GREP_OPTIONS
= LC_ALL
=C
egrep "$@"
118 is_bare_repository
() {
119 git rev-parse
--is-bare-repository
123 cdup
=$
(git rev-parse
--show-toplevel) &&
125 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
130 require_work_tree
() {
131 test $
(git rev-parse
--is-inside-work-tree) = true ||
132 die
"fatal: $0 cannot be used without a working tree."
135 get_author_ident_from_commit
() {
138 s/'\''/'\''\\'\'\''/g
140 s/^author \([^<]*\) <[^>]*> .*$/\1/
142 s
/.
*/GIT_AUTHOR_NAME
='\''&'\''/p
145 s
/^author
[^
<]* <\
([^
>]*\
)> .
*$
/\
1/
147 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
150 s/^author [^<]* <[^>]*> \(.*\)$/\1/
152 s
/.
*/GIT_AUTHOR_DATE
='\''&'\''/p
157 encoding=$(git config i18n.commitencoding || echo UTF-8)
158 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
159 LANG=C LC_ALL=C sed -ne "$pick_author_script"
162 # Make sure we are in a valid repository of a vintage we understand,
163 # if we require to be in a git repository.
164 if test -z "$NONGIT_OK"
166 GIT_DIR=$(git rev-parse --git-dir) || exit
167 if [ -z "$SUBDIRECTORY_OK" ]
169 test -z "$(git rev-parse --show-cdup)" || {
171 echo >&2 "You need to run this command from the toplevel of the working tree."
175 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
176 echo >&2 "Unable to determine absolute path of git directory"
179 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
182 # Fix some commands on Windows
185 # Windows has its own (incompatible) sort and find